/*
*Copyright: Copyright (c) 2003-2004, Lehigh University. All rights reserved.
*License Statement: The GNU General Public License
*/

package edu.lehigh.swat.hawk.core;

/**
 * Encapsulating the datatype values.
 * @author Z. Pan
 * @version 1.0
 * For now, we allow duplicate ObjectIds introduced by identical datatype
 * values.
 */

public class DatatypeValue extends ObjectId{

  /**
   * Constructor
   */
  public DatatypeValue(String v, String t){
    super(v+"&"+t);
    value = v;
    type = t;
  }

  /**
   * Get the value.
   */
  public String getValue(){
    return value;
  }


  /**
   * Get the data type. (link to XSD)
   */
  public String getType(){
    return type;
  }

  /**
   * Set the data type.
   */
  public void setType(String t){
    type = t;
  }

  public static final String INTEGER = "http://www.w3.org/2001/XMLSchema#Integer";
  public static final String STRING = "http://www.w3.org/2001/XMLSchema#STRING";
  private String value, type;

}
