/*
*Copyright: Copyright (c) 2003-2004, Lehigh University. All rights reserved.
*License Statement: The GNU General Public License
*/


package edu.lehigh.swat.hawk.core;

import java.util.Iterator;
/**
 * Superclass of OntClass etc. </p>
 * @author Z. Pan
 * @version 1.0
 */

public interface OntObject {

  /**
   * get the uri of this object
   */
  public ObjectId getID();

  /**
   * set the uri of this object
   */
  public void setID(ObjectId id);

  /**
   * set the ontology that this object belongs to
   */
  public void setOntology(Ontology o);

  /**
   * get the ontology that this object belongs to
   */
  public Ontology getOntology();

  /**
   * Set the source document.
   */
  public void setSource(Document d);

  /**
   * Get the source document.
   */
  public Document getSource();

  /**
   * Get the first description.
   */
  public String getDescription();

  /**
   * Get all the descriptions.
   */
  public Iterator getAllDescriptions();

  /**
   * Add a description, comment, etc.
   */
  public void addDescription(String des);

  /**
   * Delete a description.
   */
  public void deleteDescription(String des);

  /**
   * Get the label.
   */
  public String getLabel();

  /**
   * Set the label.
   */
  public void setLabel(String label);
}