/*
*Copyright: Copyright (c) 2003-2004, Lehigh University. All rights reserved.
*License Statement: The GNU General Public License
*/


package edu.lehigh.swat.hawk.core;
import java.io.InputStream;
import edu.lehigh.swat.hawk.storage.StorageModel;

/**
 * Document reader, read a file into storage</p>
 * @author Z. Pan
 * @version 1.0
 */

public abstract class OntReader {

  /**
   * Constructor
   */
  public OntReader() {

    loadImports = true;
    allowUpdate = true;
  }


  /**
   * Read the input into the model and return the corresponding docuement object.
   */
  public abstract Document read(InputStream in) throws Exception;

  /**
   * set whether or not to load imported documents
   */
  public void setLoadImports(boolean imp){
    loadImports = imp;
  }

  /**
   * set whether or not to replace loaded document
   */
  public void setAllowUpdate(boolean up){
    allowUpdate = up;
  }

  /**
   * test if imported documents are to be loaded
   */
  public boolean getLoadImports(){
    return loadImports;
  }

  /**
   * test if allow updating loaded document
   */
  public boolean getAllowUpdate(){
    return allowUpdate;
  }


  private boolean loadImports;
  private boolean allowUpdate;
}
