package edu.lehigh.swat.hawk.owl;

import java.io.*;
import java.net.*;
//import com.hp.hpl.jena.rdf.arp.JenaReader;


/**
 * An xml parser to parse namespces etc.
 * @author Z. Pan
 * @version 1.0
 */
class PreParser {

  public PreParser(String uri) {

     xmlBase = null;
     ins = null;
     ByteArrayInputStream bin=null, bin2=null;
     ByteArrayOutputStream bout = new ByteArrayOutputStream();
      try {
          URL url = new URL(uri);
          long t0 = System.currentTimeMillis();
          URLConnection uc = url.openConnection();
          uc.addRequestProperty("Content-Type","RDF");
          uc.setConnectTimeout(10000);
          uc.setReadTimeout(60000);
          InputStream is = uc.getInputStream();
          BufferedInputStream bis = new BufferedInputStream(is);

          byte[] buf = new byte[10240];
          int len = 0;
          while((len = bis.read(buf))>0){
              bout.write(buf,0,len);
              if(xmlBase==null){
                  String s = new String(buf);
                  s = s.toLowerCase();
                  int rdf = s.indexOf("rdf:rdf");
                  if(rdf<0){
                      System.out.println("HAWK: Not a valid RDF document");
                      return;
                  }
                  int ind = s.indexOf("xml:base");
                  if(ind>0){
                      int ind1 = s.indexOf("\"", ind);
                      int ind2 = s.indexOf("\"", ind1 + 2);
                      String base = s.substring(ind1+1, ind2);
                      xmlBase = base;
                  }
                  else
                      xmlBase = "";
              }
          }
          long t1 = System.currentTimeMillis()-t0;
          System.out.println("time in network: "+t1);
          int blen = bout.size();
          buf = new byte[blen];
          buf = bout.toByteArray();
//          bin = new ByteArrayInputStream(buf);
          bin2 = new ByteArrayInputStream(buf);

 //         DocumentBuilderFactory factory =
 //           DocumentBuilderFactory.newInstance();
 //         factory.setValidating(false);
 //         DocumentBuilder builder = factory.newDocumentBuilder();
//        document = builder.parse(bin);
//          bin.close();
          is.close();
          bis.close();

      }catch(Exception e){
          System.out.println(e.toString());
          e.printStackTrace();
      }
      //xmlBase = "";
      ins= bin2;
  }

  public PreParser(InputStream is) {
      try{
          BufferedInputStream bis = new BufferedInputStream(is);
          byte[] buf = new byte[10240];
 //         int len = 0;
          if (bis.read(buf) > 0) {
              //bout.write(buf,0,len);
                  String s = new String(buf);
                  s = s.toLowerCase();
                  int rdf = s.indexOf("rdf:rdf");
                  if (rdf < 0) {
                      System.out.println("HAWK: Not a valid RDF document");
                      return;
                  }
                  int ind = s.indexOf("xml:base");
                  if (ind > 0) {
                      int ind1 = s.indexOf("\"", ind);
                      int ind2 = s.indexOf("\"", ind1 + 2);
                      String base = s.substring(ind1 + 1, ind2);
                      xmlBase = base;
                  } else
                      xmlBase = "";
              }
           else
               System.out.println("preparser: input is empty");
      }catch(Exception e){
          System.out.println(e.toString());
          e.printStackTrace();
      }
  }

  public PreParser(Reader uri) {
   //deprecated ???  // z.pan
  }

  /**
   * Get the namespaces and their prefixes.
   * @return

  public HashMap getNamespaces(){
    HashMap map = new HashMap();
    Element elem = document.getDocumentElement();
    if(elem == null || !elem.getNodeName().equalsIgnoreCase("rdf:RDF")){
        System.out.println("HAWK: Not a valid RDF document");
        ins = null;
        return null;
    }
    NamedNodeMap nm = document.getDocumentElement().getAttributes();
    int len = nm.getLength();
    for(int i=0;i<len;i++){
      Node node = nm.item(i);
      if(node.getNodeName().startsWith("xmlns")){
        String name = node.getNodeName();
        String url = node.getNodeValue();
        if(name.equalsIgnoreCase("xmlns"))
            map.put(url,"");
        else{
            String prefix = name.substring(6);
            map.put(url, prefix);
        }
      }
      if(node.getNodeName().equalsIgnoreCase("xml:base"))
        xmlBase = node.getNodeValue();
        if(xmlBase.endsWith("#")){
            xmlBase = xmlBase.substring(0,xmlBase.length()-1);
        }
    }
    return map;
  }
*/

  /**
   * Get the XML Base. Note this method has to be called after getNamespaces().
   * @return
   */
  public String getXMLBase(){
    return xmlBase;
  }

  public InputStream getInputStream(){
      return ins;
  }

  private String xmlBase;
  private InputStream ins;
}
