/*
*Copyright: Copyright (c) 2003-2004, Lehigh University. All rights reserved.
*License Statement: The GNU General Public License
*/

package edu.lehigh.swat.hawk.storage.ontper.dldb;

import java.sql.*;
import java.util.*;
import java.io.*;
import edu.lehigh.swat.hawk.core.ObjectId;
import edu.lehigh.swat.hawk.core.DocId;
import edu.lehigh.swat.hawk.storage.Result;
import edu.lehigh.swat.hawk.storage.simpledb.*;

/**
 * Database storage model that supports perspectives
 * @author Z. Pan
 * @version 1.0
 */

public class DldbStorage extends edu.lehigh.swat.hawk.storage.dldb.DldbStorage{
/**
 * Constructor.
 * @param DBName
 */
 public DldbStorage(String DBName) {
  super(DBName);
 }

 /**
 * Create an Ontology object.
 */
 public edu.lehigh.swat.hawk.core.Ontology createOntology(){
   edu.lehigh.swat.hawk.storage.dlmemory.Ontology mOnto =
      new edu.lehigh.swat.hawk.storage.dlmemory.Ontology();
   Ontology onto = new Ontology(mOnto);
   onto.setDocSeq(++sourceSeqNum);
   onto.setOntSeq(++ontSeqNum);
   onto.setSQLStatement(stmt);
   onto.setModel(this);
   return onto;
 }

 /**
  * Execute query and return results.
  */
 public edu.lehigh.swat.hawk.storage.ResultSet issueQuery(edu.lehigh.swat.hawk.storage.simpledb.Query qry){
   edu.lehigh.swat.hawk.storage.ResultSet rset;
   java.sql.ResultSet rs;

   Query query = (Query)qry;
   DocId persp = query.getPerspective();
   String nameSpace = getQueryOntology().concat("#");
   if(persp!=null)
     nameSpace = persp.getId().concat("#");
   int perspSeq = this.getOntSeq(nameSpace);
   //ObjectId oid = new ObjectId("");
System.out.println("perspective: "+ nameSpace+ perspSeq);
   if(propertyTypes==null)
     getPropertyTypes();

   int ptype=0;
   Vector a = query.getAtoms();
   int l = a.size();

   StringBuffer colName = new StringBuffer("SELECT DISTINCT ");
   StringBuffer tableName = new StringBuffer("FROM ");
   StringBuffer condition = new StringBuffer("WHERE ");
//    int hasname=0;
   int colnum = 0;
   Vector vcol = new Vector();
   vcol.clear();

   Hashtable tables = new Hashtable();
   tables.clear();

 //  Vector columns = new Vector();//new for alias
 //  columns.clear(); //--

   Hashtable classes = new Hashtable();
   Hashtable properties = new Hashtable();

   for(int i=0;i<l;i++){
     ptype=0;
     Atom am = (Atom) a.get(i);
     String sp = am.toString();
     System.out.println(sp);

     String amp = am.getPredicate();
     String[] ama = am.getArguments();
     if(amp.startsWith("@every")||amp.startsWith("type"))
     ptype=1;
     if(amp.startsWith("@string"))
     ptype=2;

     String tn;

     switch(ptype){
     case 1:
             ObjectId objid;
             if(ama[0].indexOf('#')>0||ama[0].indexOf('/')>0)
               objid = new ObjectId(ama[0]);
             else
               objid = new ObjectId(nameSpace+ama[0]);

             tn = getTableName(objid);
             tn = tn+"_"+perspSeq;
             tn = tn + "_view";
             if(!tables.containsKey(tn)){
                 tableName.append(tn).append(", ");
                 tables.put(tn, "class");
             }
             else{
                 tn = tn+i;
                 tableName.append(tn).append(", ");
                 tables.put(tn,"class");
             }
             if(properties.get(ama[1])==null){
               tableName.append("uri_index AS ui" + i + ", ");
               colName.append("ui" + i + ".uri, ");
               condition.append(tn + ".id = ui" + i + ".id AND ");
               vcol.add(ama[1]);
               classes.put(ama[1], tn + ".id");
             }else{
               condition.append(properties.get(ama[1])).append("=");
               condition.append(tn).append(".id AND ");
             }
     break;
     case 2:
             //colName.append("url_index.url, url_index.id, ");
             if(properties.get(ama[0])!=null){
               String fullname = (String)properties.get(ama[0]);
               int dot = fullname.indexOf('.');
               String tname = fullname.substring(0,dot-5);
          //     String cname = fullname.substring(dot);
               String type = "";
               try{
  /*               rs = con.getMetaData().getColumns("","",tname,cname);
                 if(rs.next())
                   type = rs.getString("TYPE_NAME");
   */
              int us = tname.lastIndexOf('_');
              tname = tname.substring(0,us);
            //  System.out.println(tname);
              type = (String)propertyTypes.get(tname);
               }
               catch(Exception e)
               {
                System.out.println(e.getMessage());
               }

               if(type.equalsIgnoreCase("object"))
               {
                 tableName.append("uri_index AS ui"+i+", ");
                 condition.append("ui"+i+".uri");
                 condition.append(" LIKE '").append(ama[1]).append("' AND ");
                 condition.append(properties.get(ama[0]));
                 condition.append("=").append("ui"+i+".id AND ");
               }
               else
               {
                 condition.append(properties.get(ama[0]));
                 condition.append(" LIKE '%").append(ama[1]).append("%' AND ");
               }
             }
     break;
     default:
             ObjectId oid;
             if(amp.indexOf('#')>0||amp.indexOf('/')>0)
               oid = new ObjectId(amp);
             else
               oid = new ObjectId(nameSpace+amp);
             tn = getTableName(oid)+"_p";
             String tn1 = tn+"_"+perspSeq;

           //  System.out.println(tn);
             if(((String)propertyTypes.get(tn)).equals("hasinverse_"+perspSeq))
                 tn1 = tn1+"_inv";
             String vn = tn1+"_view";
             if(!tables.containsKey(vn)){
               // System.out.println("tables does not have "+vn); //test
               tableName.append(vn).append(", ");
               tables.put(vn,"property");
             }
             else{
                 vn = vn+i;
                 tableName.append(vn).append(", ");
                 tables.put(vn,"property");
             }
             String type = (String)propertyTypes.get(tn);
             if(type!=null&&type.equalsIgnoreCase("datatype")){
               tables.remove(vn);
               tables.put(vn, "datatype");
             }

             //second argument, object.
             if(ama[1].startsWith("?")){
               if(classes.get(ama[1])!=null){
                 condition.append(classes.get(ama[1])).append("=");
                 condition.append(vn).append(".object AND ");
               }
               if(properties.get(ama[1])!=null){
                 condition.append(properties.get(ama[1])).append("=");
                 condition.append(vn).append(".object AND ");
               }
               if(properties.get(ama[1])==null&&classes.get(ama[1]) == null){
                   String select_column_name = vn+".object";
                   if(type!=null&&type.equalsIgnoreCase("datatype")){
                     colName.append(select_column_name).append(", ");
                   }
                   else{
                     tableName.append("uri_index AS uio"+i+", ");
                     colName.append("uio"+i+".uri, ");
                     condition.append(select_column_name+" = uio"+i+".id AND ");
                   }
                   properties.put(ama[1], select_column_name);
                   //System.out.println("put properties:"+ama[1]+","+select_column_name); //test
                   vcol.add(ama[1]);
               }
             }
             else{// argument is not variable
               tableName.append("uri_index AS uio"+i+", ");
               condition.append("uio"+i+".uri='").append(ama[1]).append("' AND ");
               condition.append(vn).append(".object=uio"+i+".id AND ");
             }

             //first argument, subject.
             if(ama[0].startsWith("?")){
               if (properties.get(ama[0]) != null) {
                 condition.append(properties.get(ama[0])).append("=");
                 condition.append(vn).append(".subject ").append(" AND ");
               }
               if (classes.get(ama[0]) != null){
                 condition.append(classes.get(ama[0])).append("=");
                 condition.append(vn).append(".subject AND ");
               }
               if(properties.get(ama[0])==null&&classes.get(ama[0]) == null){
                 String select_column_name = vn + ".subject";
                 tableName.append("uri_index AS uis" + i + ", ");
                 colName.append("uis" + i + ".uri, ");
                 condition.append(select_column_name).append(" = ");
                 condition.append("uis" + i + ".id AND ");
                 vcol.add(ama[0]);
                 properties.put(ama[0], select_column_name);
               }
             }
             else{  //argument is not variable
                 tableName.append("uri_index AS uis"+i+", ");
                 condition.append("uis"+i+".uri='").append(ama[0]).append("' AND ");
                 condition.append(vn).append(".subject=uis"+i+".id AND ");
             }
         }//end switch

   }//end for
   int len = colName.length();
   colName.delete(len-2,len);
   colName.append("\n");

   len = tableName.length();
   tableName.delete(len-2,len);
   tableName.append("\n");

   len = condition.length();
   condition.delete(len-4,len);
   condition.append("\n");

   String colNames = colName.toString();
   String tableNames = tableName.toString();
   String conditions = condition.toString();

   if(conditions.length()>6)
     System.out.println(colNames+tableNames+conditions);
   else
     System.out.println(colNames+tableNames);

   colnum = vcol.size();
   String[] varnames = new String[vcol.size()];
   for(int i=0;i<colnum;i++)
   varnames[i] = (String) vcol.elementAt(i);

   rset = new edu.lehigh.swat.hawk.storage.ResultSet();

   long t0 = System.currentTimeMillis();// test
   if(dbName.indexOf("mysql")>0&&(0>1)){
//     rs.close();  //zpan
     try{
       Enumeration en = tables.keys();
       stmt.clearBatch();
       while(en.hasMoreElements()){
         String tname = (String)en.nextElement();
         String ttype = (String)tables.get(tname);
//         if(ttype.equalsIgnoreCase("multi-references"))
//             continue;
         String temptable = "create temporary table "+tname;
         if(ttype.equals("property")){
           temptable =
           temptable+" (subject int, object int, source int, onto int, key(subject), key(object))";
         }else if(ttype.equals("datatype")){
           //temptable =
           //temptable+" (subject int, object TEXT, source int, onto int, key(subject))";
           continue;
         }else
           temptable = temptable+" (id int, source int, onto int, key(id))";

         if(!tname.endsWith("w"))
             tname = tname.substring(0,tname.length()-1);
         temptable = temptable+" select * from "+tname+";";
         System.out.println("create temp table for "+tname);
         stmt.execute(temptable);
       }
      // stmt.executeBatch();
    }catch(SQLException e){
    System.out.println("error when create temp tables");
    System.out.println(e.getMessage());
    System.out.println(e.getErrorCode());
    }
  }

  //zhp2: for hsqsldb
/*   if(dbName.indexOf("hsql")>0){

          Enumeration en = tables.keys();
          while (en.hasMoreElements()) {
              String tname = (String) en.nextElement();
              String qs0 = "drop view "+tname;
              String qs = this.getViewDefinition(tname);
              try{
                  stmt.execute(qs0);
                  stmt.execute("drop view undergraduatestudent_1_view");
            } catch(Exception e){
                      e.printStackTrace();
                }
              try{
                    System.out.println(qs);
                      stmt.execute(qs);
      //                System.out.println(qs);
                  } catch(Exception e){
                          e.printStackTrace();
                  }

         }
  }
*/
  try{
   if(conditions.length()>6)
     rs = stmt.executeQuery(colNames+tableNames+conditions);
   else
     rs = stmt.executeQuery(colNames+tableNames);
   //test
   long t1 = System.currentTimeMillis();
   long t = t1-t0;
   System.out.println("\n\ntime in SQL query: "+t+"ms.");
   //end test

   while(rs.next())
   {
     String[] data = new String[colnum];
     for(int i=0;i<colnum;i++)
     {
       data[i] = rs.getString(i+1);
     }

     rset.addResult(new Result(data));
   }

//    rset.setSqlResult(rs);
 //  rs.close();
   }

   catch(SQLException e){
       System.out.println("error when do query");
       System.out.println(e.getMessage());
     //  System.out.println(e.getErrorCode());
   }

   return rset;

  }


}
