/*
*Copyright: Copyright (c) 2003-2004, Lehigh University. All rights reserved.
*License Statement: The GNU General Public License
*/


package edu.lehigh.swat.hawk.storage.ontper.dldb;

import edu.lehigh.swat.hawk.core.DocId;
import edu.lehigh.swat.hawk.core.ObjectId;
import edu.lehigh.swat.hawk.core.Document;
import java.sql.*;
import java.util.*;
import edu.lehigh.swat.hawk.core.Axiom;
import edu.lehigh.swat.hawk.core.AxiomNode;

/**
 * <p>encapsulating the web ontology </p>
 * @author Z. Pan
 * @version 1.0
 */

public class Ontology extends edu.lehigh.swat.hawk.storage.dldb.Ontology{

  /**
   * Constructor
   *
   */
  public Ontology(edu.lehigh.swat.hawk.storage.dlmemory.Ontology mOnto){
        super(mOnto);
//        this.memoryOnto = mOnto;
  }

  /**
   * add a class to this ontology
   */
  public void addOntClass(edu.lehigh.swat.hawk.core.OntClass c){
    memoryOnto.addOntClass(c);

    if(compatibleOntos==null)
      this.getCompatiblePriorOnts();

    String tableName = model.getTableName(c.getID());
    String className = c.getID().getLocalName(); //add for persp
    if(tableName==null)
      return;
    String qs = "CREATE TABLE "+tableName
    +" (\nID INTEGER not null,\nSOURCE INTEGER not null,ONTO INTEGER,\nPRIMARY KEY(ID,SOURCE)\n)";

    try{
      stmt.executeUpdate(qs);
    }
     catch(SQLException e){
                System.out.println("error when store class");
                System.out.println(qs);
                System.out.println("SQLState:"+e.getSQLState());
                System.out.println("Message :"+e.getMessage());
                System.out.println("Vendor  :"+e.getErrorCode());

              }

      String qs2 = "";
      String viewName = tableName+"_"+String.valueOf(ontSeq)+"_view";

      qs2 = "CREATE VIEW "+viewName+" AS\n SELECT * FROM "+tableName
          +" WHERE ONTO="+ontSeq;

        int size = compatibleOntos.size();
        for(int i=0;i<size;i++){
          Ontology cmpOnt = (Ontology)compatibleOntos.get(i);
          if(cmpOnt.hasClass(className))
            qs2+=" UNION SELECT * FROM "+className+"_"+cmpOnt.getOntSeq()
                +" WHERE ONTO="+cmpOnt.getOntSeq();
        }

      String qs3 = "";
      String qs4= "Insert into tables_index values ('"+tableName+"', "+ontSeq+", "+memoryOnto.getClassIndex(c.getID())+")"; //zhp2: insert tables_index
      try{
        qs3 = "INSERT INTO view_definition VALUES ('"+viewName+"', '"+qs2+"')";
        stmt.executeUpdate(qs2);
        stmt.executeUpdate(qs3);
        stmt.executeUpdate(qs4);
      }
      catch(SQLException e){
        System.out.println("error when store class, create view");
        System.out.println(qs2);
        System.out.println("SQLState:"+e.getSQLState());
        System.out.println("Message :"+e.getMessage());
        System.out.println("Vendor  :"+e.getErrorCode());
      }
  }



  /**
   * add a property to this ontology
   */
  public void addProperty(edu.lehigh.swat.hawk.core.OntProperty prop){
    memoryOnto.addProperty(prop);
    if(dbName==null)
        dbName = ((DldbStorage)getModel()).getDBName();
    if(compatibleOntos==null)
      this.getCompatiblePriorOnts();

    String tableName = model.getTableName(prop.getID());
    String propName = prop.getID().getLocalName();
    if(tableName==null)
      return;
    String qs = "";
    String indexs = "";
    String indexo = "";
    String pinfo = "INSERT INTO propertytypes VALUES('";
    tableName = tableName+"_p";
    if((prop.isDatatype()!=null && !prop.isDatatype().booleanValue())||
        prop.isFunctional()||prop.isTransitive()||prop.isInverseFunctional()||
         prop.isSymmetric()){
      qs = "CREATE TABLE "+tableName
    +" ( SUBJECT INTEGER not null, OBJECT INTEGER not null, SOURCE INTEGER not null, ONTO INTEGER,"+
    " PRIMARY KEY(SUBJECT,OBJECT,SOURCE), index(object))";
      pinfo += tableName+"', 'object')";
      if(dbName.indexOf("jdbc:db2")>0){
          qs = "CREATE TABLE "+tableName
        +" ( SUBJECT INTEGER not null, OBJECT INTEGER not null, SOURCE INTEGER not null, ONTO INTEGER,"+
    " PRIMARY KEY(SUBJECT,OBJECT,SOURCE))";
      }
    }
    else{
      ObjectId range = prop.getRange();
      if(range!=null&&range.getNameSpace().equalsIgnoreCase("http://www.w3.org/2001/XMLSchema#")){
          if(range.getLocalName().toLowerCase().endsWith("integer")){
              qs = "CREATE TABLE "+tableName
                   +" ( SUBJECT INTEGER, OBJECT INTEGER,"+
                   " SOURCE INTEGER, ONTO INTEGER,"+
                   " PRIMARY KEY(SUBJECT,OBJECT,SOURCE))";
              pinfo += tableName+"', 'int')";
          }
          else if(range.getLocalName().toLowerCase().endsWith("float")){
              qs = "CREATE TABLE "+tableName
                   +" (SUBJECT INTEGER not null, OBJECT FLOAT not null,"+
                   " SOURCE INTEGER not null, ONTO INTEGER,"+
                   " PRIMARY KEY(SUBJECT,OBJECT,SOURCE))";
              pinfo += tableName+"', 'float')";
          }
          else if(range.getLocalName().toLowerCase().endsWith("date")){ // Ameet Aug 30, 2007
                        qs = "CREATE TABLE "+tableName
                             +" (SUBJECT INTEGER not null, OBJECT DATE not null,"+
                             " SOURCE INTEGER not null, ONTO INTEGER,"+
                             " PRIMARY KEY(SUBJECT,OBJECT,SOURCE))";
                        pinfo += tableName+"', 'date')";
          }
      }
      if(qs.length()<1){
          if(dbName.indexOf(".mdb")>0)
              qs = "CREATE TABLE " + tableName
               + " (SUBJECT INTEGER, OBJECT MEMO,"
               +" SOURCE INTEGER,ONTO INTEGER," +
               " INDEX(SUBJECT, OBJECT))";
      else if(dbName.indexOf("jdbc:db2")>0){
          qs = "CREATE TABLE " + tableName
            + " (SUBJECT INTEGER not null, OBJECT CLOB(4096),"
            +" SOURCE INTEGER not null, ONTO INTEGER," +
            " unique (SUBJECT))";
      }
          else
             qs = "CREATE TABLE " + tableName
               + " (SUBJECT INTEGER not null, OBJECT TEXT not null,"
               +" SOURCE INTEGER not null, ONTO INTEGER," +
               " INDEX (SUBJECT, OBJECT(10)))";
          pinfo += tableName + "', 'datatype')";
      }
    }

   // log.println(qs);

    try{
      stmt.executeUpdate(qs);
      stmt.executeUpdate(pinfo);
    }
    catch(SQLException e){
                //log.println("error when store property");
      System.out.println("error when store property");
      System.out.println("SQLState:"+e.getSQLState());
      System.out.println("Message :"+e.getMessage());
      System.out.println("Vendor  :"+e.getErrorCode());
    }

      String qs2 = "";
      String viewName = tableName+"_"+String.valueOf(ontSeq)+"_view";
  //    if(viewSeqNum == currentSeqNum){

        qs2 = "CREATE VIEW "+viewName+" AS\n SELECT * FROM "+tableName
            +" WHERE ONTO="+ontSeq;

        int size = compatibleOntos.size();
        for(int i=0;i<size;i++){
          Ontology cmpOnt = (Ontology)compatibleOntos.get(i);
          if(cmpOnt.hasClass(propName))
            qs2+=" UNION SELECT * FROM "+propName+"_"+cmpOnt.getOntSeq()
                +" WHERE ONTO="+cmpOnt.getOntSeq();
        }



      String qs3 = "";
      String qs4= "Insert into tables_index values ('"+tableName+"', "+ontSeq+", "+memoryOnto.getPropertyIndex(prop.getID())+")"; //zhp2: insert tables_index
      try{
        qs3 = "INSERT INTO view_definition VALUES ('"+viewName+"', '"+qs2+"')";
        stmt.executeUpdate(qs2);
        stmt.executeUpdate(qs3);
        stmt.executeUpdate(qs4);
      }

      catch(SQLException e){
              //  log.println("error when store class, create view");
        System.out.println(qs2);
        System.out.println("error when store class, create view");
        System.out.println("SQLState:"+e.getSQLState());
        System.out.println("Message :"+e.getMessage());
        System.out.println("Vendor  :"+e.getErrorCode());
      }
  }

  /**
   * Flush the axioms into database.
   */
  public void flush(){
      flushImports();
      super.flush();
/*
    DocId[] dids = memoryOnto.getImports();
    edu.lehigh.swat.hawk.core.Ontology[] imports = null;
    if(dids!=null){
      int len = dids.length;
      imports = new edu.lehigh.swat.hawk.core.Ontology[len];
      for(int i=0;i<len;i++){
        DocId did = dids[i];
        Document doc = model.getDocument(did.getId());
        if(doc instanceof edu.lehigh.swat.hawk.core.Ontology){
          edu.lehigh.swat.hawk.core.Ontology iont = (edu.lehigh.swat.hawk.core.
              Ontology) doc;
          imports[i] = iont;
        }
      }
    }
    ((edu.lehigh.swat.hawk.storage.dlmemory.Ontology) memoryOnto)
        .computeSubsumptions(((DldbStorage)this.getModel()).getReasonerUrl(),imports);

    dbName = ((DldbStorage)getModel()).getDBName();
    flushImports();  //added by z.pan
    flushSubs();
    flushEquivals();
    flushInverseOf();
    if(getAllProperties().length>0){
        model.updatePropertyTypes();  //zhop2: every time add a new ontology, update the property types info.
    }
    model.storeOntology(this);
*/
  }

  private String getNodeView(AxiomNode node){
      int type = node.getJoinType();
      if(type==edu.lehigh.swat.hawk.core.Ontology.ATOMICNODE){
              String tname = model.getTableName(node.getAtomicNode());
              if(tname==null)
                  return null;
              String vname = tname + "_" + String.valueOf(ontSeq) + "_view";
              return "SELECT * FROM " + vname;
      }
      else if (type==edu.lehigh.swat.hawk.core.Ontology.SOMEVALUERESTRICTION) {
              String pvname = model.getTableName(node.getOnProperty().getAtomicNode())+"_p_"+String.valueOf(ontSeq) + "_view";
              String cvname = getNodeView(node.getSomeValuesFrom()).substring(14);
              return "SELECT subject AS ID, "+pvname+".source, "+pvname+".onto FROM "
                      + pvname +", "+cvname
                      +" where " + pvname + ".object = "+cvname+".ID";
              //zhp2: MySQL doesn't support subquery in from clause of view definition. Thus the class has to be atomic.
      }
      else if(type==edu.lehigh.swat.hawk.core.Ontology.INTERSECTIONOF){
          String view = "";
          List<AxiomNode> list = node.getChildren();
          Iterator<AxiomNode> it = list.iterator();
          while(it.hasNext()){
              AxiomNode child = it.next();
              if(view.length()<1)
                  view = getNodeView(child);
              else{
                  if(child.getAtomicNode()!=null)
                      view = view + " WHERE ID IN (select id from "+ getNodeView(child).substring(14) + ")";
                  else{
                      String temp = getNodeView(child);
                      int start = temp.indexOf(" AS ID");
                      int end = temp.indexOf(" FROM");
                      String ins = temp.substring(0,start+6)+temp.substring(end);
                      view = view + " WHERE ID IN ( "+ ins + ")";
                  }

              }
          }
          return view;
      }
      return "";
  }

  private String getNodeView(AxiomNode node, ObjectId rightHand, boolean isProperty){
      int type = node.getJoinType();
      if(type==edu.lehigh.swat.hawk.core.Ontology.ATOMICNODE){
              String tname = model.getTableName(node.getAtomicNode());
              if(tname==null)
                  return null;
              if(isProperty)
                  tname = tname + "_p";
              return "SELECT * FROM " + tname;
      }
      else if (type==edu.lehigh.swat.hawk.core.Ontology.SOMEVALUERESTRICTION) {
              String pvname = model.getTableName(node.getOnProperty().getAtomicNode())+"_p_"+String.valueOf(ontSeq) + "_view";
              String cvname = getNodeView(node.getSomeValuesFrom()).substring(14);
              return "SELECT subject AS ID, "+pvname+".source, "+pvname+".onto FROM "
                      + pvname +", "+cvname
                      +" where " + pvname + ".object = "+cvname+".ID";
              //zhp2: MySQL doesn't support subquery in from clause of view definition. Thus the class has to be atomic.
      }
      else if(type==edu.lehigh.swat.hawk.core.Ontology.INTERSECTIONOF){
          String view = "";
          List<AxiomNode> list = node.getChildren();
          Iterator<AxiomNode> it = list.iterator();
          boolean lastIsQuery = false;
          while(it.hasNext()){
              AxiomNode child = it.next();
              if(child.getAtomicNode()!=null&&((edu.lehigh.swat.hawk.storage.simplememory.OntClass)getOntClass(child.getAtomicNode())).subsumes(rightHand))
                  continue;
              if(view.length()<1){
                  view = getNodeView(child);
                  lastIsQuery = true;
              }
              else{
                  if(child.getAtomicNode()!=null){
                      if(lastIsQuery)
                          view = view + " and ID IN (select id from "+ getNodeView(child).substring(14) + ")";
                      else
                          view = view + " WHERE ID IN (select id from "+ getNodeView(child).substring(14) + ")";
                  }
                  else{
                      String temp = getNodeView(child);
                      int start = temp.indexOf(" AS ID");
                      int end = temp.indexOf(" FROM");
                      String ins = temp.substring(0,start+6)+temp.substring(end);
                      view = view + " WHERE ID IN ( "+ ins + ")";
                  }
              }
          }
          return view;
      }
      return "";
  }

  protected void flushSubs(){
    //deal with subClass
    List<Axiom> subaxioms = this.getAllAxiomsByType().get(edu.lehigh.swat.hawk.core.Ontology.SUBCLASSOF);
    if(subaxioms!=null){
        Iterator<Axiom> it = subaxioms.iterator();
        while (it.hasNext()) {
            Axiom axiom = it.next();
            AxiomNode left = axiom.getLeftAxiomNode();
            AxiomNode right = axiom.getRightAxiomNode();
            String leftView = getNodeView(left);
            String className = model.getTableName(right.getAtomicNode());
            if (className == null || leftView==null)
                continue;
            String vName = className + "_" + String.valueOf(ontSeq) + "_view";
            StringBuffer cvb;

            String def = model.getViewDefinition(vName);
            if (def == null) {
                System.out.println("view definition not found:" + vName);
                continue;
            } else
                cvb = new StringBuffer(def);
            if (leftView == null)
                continue;
            cvb.append(" UNION " + leftView);
            model.setViewDefinition(vName, cvb.toString());
        }
    }
    //deal with subProperty
   List<Axiom> subpaxioms = this.getAllAxiomsByType().get(edu.lehigh.swat.hawk.core.Ontology.SUBPROPERTYOF);
   if(subpaxioms!=null){
       Iterator<Axiom> itp = subpaxioms.iterator();
       while (itp.hasNext()) {
           Axiom axiom = itp.next();
           AxiomNode left = axiom.getLeftAxiomNode();
           AxiomNode right = axiom.getRightAxiomNode();
           String leftp = model.getTableName(left.getAtomicNode());
           String rightp = model.getTableName(right.getAtomicNode());
           if (leftp == null || rightp == null)
               continue;
           String leftView = "SELECT * FROM " + leftp + "_p_" +
                             String.valueOf(ontSeq) + "_view";
           String vName = rightp + "_p_" + String.valueOf(ontSeq) + "_view";
           StringBuffer cvb;

           String def = model.getViewDefinition(vName);
           if (def == null) {
               System.out.println("view definition not found:" + vName);
               continue;
           } else
               cvb = new StringBuffer(def);
           if (leftView == null)
               continue;
           cvb.append(" UNION " + leftView);
           model.setViewDefinition(vName, cvb.toString());
       }
   }
  }

  protected void flushEquivals(){
    //deal with equivalentClass
    List<Axiom> subaxioms = this.getAllAxiomsByType().get(edu.lehigh.swat.hawk.core.Ontology.EQUIVALENTCLASS);
    if(subaxioms!=null){
        Iterator<Axiom> it = subaxioms.iterator();
        while (it.hasNext()) {
            Axiom axiom = it.next();
            AxiomNode left = axiom.getLeftAxiomNode();
            AxiomNode right = axiom.getRightAxiomNode();
            String className = "";
            String subView = "";

            if (left.getAtomicNode() != null) {
                className = model.getTableName(left.getAtomicNode());
                subView = getNodeView(right, left.getAtomicNode(), false);
                String vName = className + "_" + String.valueOf(ontSeq) +
                               "_view";
                StringBuffer cvb;

                String def = model.getViewDefinition(vName);
                if (def == null) {
                    System.out.println("view definition not found:" + vName);
                } else{
                    cvb = new StringBuffer(def);
                    if (subView != null && !subView.equals("")) {
                        if (left.getJoinType() ==
                            edu.lehigh.swat.hawk.core.Ontology.ATOMICNODE &&
                            right.getJoinType() ==
                            edu.lehigh.swat.hawk.core.Ontology.ATOMICNODE &&
                            subView.indexOf(" UNION") > 1)
                            cvb.append(" UNION " +
                                       subView.substring(0,
                                    subView.indexOf(" UNION")));
                        else
                            cvb.append(" UNION " + subView);
                        model.setViewDefinition(vName, cvb.toString());
                    }
                }
            }
            if (right.getAtomicNode() != null) {
                className = model.getTableName(right.getAtomicNode());
                subView = getNodeView(left, right.getAtomicNode(), false);
                String vName = className + "_" + String.valueOf(ontSeq) +
                               "_view";
                StringBuffer cvb;

                String def = model.getViewDefinition(vName);
                if (def == null) {
                    System.out.println("view definition not found:" + vName);
                } else{
                    cvb = new StringBuffer(def);
                    if (subView != null && !subView.equals("")) {
                        if (left.getJoinType() ==
                            edu.lehigh.swat.hawk.core.Ontology.ATOMICNODE &&
                            right.getJoinType() ==
                            edu.lehigh.swat.hawk.core.Ontology.ATOMICNODE &&
                            subView.indexOf(" UNION") > 1)
                            cvb.append(" UNION " +
                                       subView.substring(0,
                                    subView.indexOf(" UNION")));
                        else
                            cvb.append(" UNION " + subView);
                        model.setViewDefinition(vName, cvb.toString());
                    }
                }
            }
        }
    }


    //deal with equivalentProperty
    List<Axiom> equipaxioms = this.getAllAxiomsByType().get(edu.lehigh.swat.hawk.core.Ontology.EQUIVALENTPROPERTY);
    if(equipaxioms!=null){
        Iterator<Axiom> it = equipaxioms.iterator();
        while (it.hasNext()) {
            Axiom axiom = it.next();
            AxiomNode left = axiom.getLeftAxiomNode();
            AxiomNode right = axiom.getRightAxiomNode();
            String propertyName = "";
            String subView = "";

            if (left.getAtomicNode() != null) {
                propertyName = model.getTableName(left.getAtomicNode())+"_p";
                subView = getNodeView(right, left.getAtomicNode(), true);
                String vName = propertyName + "_" + String.valueOf(ontSeq) +
                               "_view";
                StringBuffer cvb;

                String def = model.getViewDefinition(vName);
                if (def == null) {
                    System.out.println("view definition not found:" + vName);
                } else{
                    cvb = new StringBuffer(def);
                    if (subView != null && !subView.equals("")) {
                        if (left.getJoinType() ==
                            edu.lehigh.swat.hawk.core.Ontology.ATOMICNODE &&
                            right.getJoinType() ==
                            edu.lehigh.swat.hawk.core.Ontology.ATOMICNODE &&
                            subView.indexOf(" UNION") > 1)
                            cvb.append(" UNION " +
                                       subView.substring(0,
                                    subView.indexOf(" UNION")));
                        else
                            cvb.append(" UNION " + subView);
                        model.setViewDefinition(vName, cvb.toString());
                    }
                }
            }
            if (right.getAtomicNode() != null) {
                propertyName = model.getTableName(right.getAtomicNode())+"_p";
                subView = getNodeView(left, right.getAtomicNode(), true);
                String vName = propertyName + "_" + String.valueOf(ontSeq) +
                               "_view";
                StringBuffer cvb;

                String def = model.getViewDefinition(vName);
                if (def == null) {
                    System.out.println("view definition not found:" + vName);
                } else{
                    cvb = new StringBuffer(def);
                    if (subView != null && !subView.equals("")) {
                        if (left.getJoinType() ==
                            edu.lehigh.swat.hawk.core.Ontology.ATOMICNODE &&
                            right.getJoinType() ==
                            edu.lehigh.swat.hawk.core.Ontology.ATOMICNODE &&
                            subView.indexOf(" UNION") > 1)
                            cvb.append(" UNION " +
                                       subView.substring(0,
                                    subView.indexOf(" UNION")));
                        else
                            cvb.append(" UNION " + subView);
                        model.setViewDefinition(vName, cvb.toString());
                    }
                }
            }
        }
    }

    Hashtable<String,String> viewDefs = model.getUpdatedViewDefs();
    Enumeration enu = viewDefs.keys();
    while(enu.hasMoreElements()){
        String vName = (String)enu.nextElement();
        String def = (String)viewDefs.get(vName);
        StringBuffer cvb = new StringBuffer(def);
        try {
            if (dbName.indexOf("mysql") > 0)
                stmt.execute(cvb.insert(7, "OR REPLACE ").toString());
            else{
                String dv = "drop view "+vName;
                stmt.execute(dv);
                stmt.execute(def);
            }
            String qs3 = "UPDATE view_definition SET definition='" + def + "'" +
                         "WHERE viewname='" + vName + "'";
            stmt.execute(qs3);
        } catch (SQLException e) {
            System.out.println("error when recreate class hierarchy");
            System.out.println(def);
            System.out.println("SQLState:" + e.getSQLState());
            System.out.println("Message :" + e.getMessage());
            System.out.println("Vendor  :" + e.getErrorCode());
        }
    }
    if(dbName.indexOf("jdbc:db2")>0){
        enu = viewDefs.keys();
        System.out.println("enumer 2nd pass");
        while(enu.hasMoreElements()){
            String vName = (String)enu.nextElement();
//            System.out.println("once more: "+vName);
            String def = (String)viewDefs.get(vName);
           // StringBuffer cvb = new StringBuffer(def);
            try {
                    stmt.execute(def);
            } catch (SQLException e) {
                if(!e.getSQLState().equals("42710")){
                    System.out.println(
                            "error when recreate class hierarchy, 2nd pass for db2");
                    System.out.println(def);
                    System.out.println("SQLState:" + e.getSQLState());
                    System.out.println("Message :" + e.getMessage());
                    System.out.println("Vendor  :" + e.getErrorCode());
                }
            }
       }
       enu = viewDefs.keys();
       System.out.println("enumer 3rd pass");
       while(enu.hasMoreElements()){
           String vName = (String)enu.nextElement();
 //          System.out.println("twicw more: "+vName);
           String def = (String)viewDefs.get(vName);
          // StringBuffer cvb = new StringBuffer(def);
           try {
                   stmt.execute(def);
           } catch (SQLException e) {
               if(!e.getSQLState().equals("42710")){
                   System.out.println(
                           "error when recreate class hierarchy, 3rd pass for db2");
                   System.out.println(def);
                   System.out.println("SQLState:" + e.getSQLState());
                   System.out.println("Message :" + e.getMessage());
                   System.out.println("Vendor  :" + e.getErrorCode());
               }
           }
       }
   }

   model.clearViewDefinitions();
  }

  /**
   * Flush owl:inverseOf into db view.
   */
  protected void flushInverseOf(){
    edu.lehigh.swat.hawk.core.OntProperty[] Properties
        = this.getAllPlusImportedProperties();
    int pNum = Properties.length;

    for (int i = 0; i < pNum; i++) {
      edu.lehigh.swat.hawk.core.OntProperty cls = Properties[i];
      if (cls.getID().getLocalName() == null || cls.getID().getLocalName() == "")
        continue;

      ObjectId[] sid = cls.getInverseOf();
      String propertyName = model.getTableName(cls.getID())+"_p";
  //  int oriSeq = model.getOntSeq(cls.getID().getNameSpace());
      String vName = propertyName  +"_"+String.valueOf(ontSeq)+ "_inv"+ "_view";

      if(cls.isSymmetric()){
          String cv = "CREATE VIEW " + vName + " AS SELECT * FROM " +
                      propertyName+" UNION SELECT "+
                      propertyName + ".OBJECT AS SUBJECT, " + propertyName
                      + ".SUBJECT AS OBJECT, " + propertyName + ".source, " +
                      propertyName + ".onto " + "FROM " + propertyName;
          try {
              stmt.execute(cv);
              String qs3 = "UPDATE view_definition SET definition='" + cv + "'" +
                           "WHERE viewname='" + vName + "'";
              stmt.execute(qs3);
              String qs4 = "UPDATE propertytypes SET type='hasinverse_" + ontSeq +
                           "' WHERE pname='" + propertyName + "'";
              stmt.execute(qs4);
          } catch (SQLException e) {
              System.out.println("error when recreate property hierarchy");
              System.out.println(cv);
              System.out.println("SQLState:" + e.getSQLState());
              System.out.println("Message :" + e.getMessage());
              System.out.println("Vendor  :" + e.getErrorCode());
          }
      }

      if (sid == null)
        continue;
      int sn = sid.length;
      if (sn <= 0)
        continue;

      String dv = "DROP TABLE " + vName;
      StringBuffer cvb;

      String def = model.getViewDefinition(vName);
      if(def==null)
        cvb = new StringBuffer("CREATE VIEW " + vName + " AS SELECT * FROM "
                               + propertyName +"_"+String.valueOf(ontSeq) + "_view ");
      else
        cvb = new StringBuffer(def);

      for (int j = 0; j < sn; j++) {
  //    int sOriSeq = model.getOntSeq(sid[j].getNameSpace());
  //   if(sOriSeq!=oriSeq)
  //        continue;
        String tName = model.getTableName(sid[j]);
        if (tName == null)
          continue;
        tName = tName + "_p"+"_"+String.valueOf(ontSeq)+"_view";
        cvb.append(" UNION SELECT ");
        cvb.append(tName + ".OBJECT AS SUBJECT, ").append(tName
              + ".SUBJECT AS OBJECT, "+tName+".source, "+tName
              +".onto "+"FROM ").append(tName);
      }
      try {
        String cv = cvb.toString();
        if (dbName.endsWith(".mdb")) {
          if(def!=null)
            stmt.execute(dv);
          stmt.execute(cv);
        }
        else if (dbName.indexOf("sql") > 0)
          stmt.execute(cvb.insert(7, "OR REPLACE ").toString());
        else if (dbName.indexOf("jdbc:db2")>0)
            stmt.execute(cv);
        String qs3 = "UPDATE view_definition SET definition='" + cv + "'" +
            "WHERE viewname='" + vName + "'";
        stmt.execute(qs3);
        String qs4 = "UPDATE propertytypes SET type='hasinverse_"+ontSeq+"' WHERE pname='"
            +propertyName+"'";
        stmt.execute(qs4);
      }
      catch (SQLException e) {
        System.out.println("error when recreate property hierarchy");
        System.out.println(cvb.toString());
        System.out.println("SQLState:" + e.getSQLState());
        System.out.println("Message :" + e.getMessage());
        System.out.println("Vendor  :" + e.getErrorCode());
      }
    }
  }

  /**
   * Flush the imported classes and properties.
   */
  private void flushImports(){
    DocId[] dids = memoryOnto.getImports();
    if(dids==null)
      return;
    int len = dids.length;
    for(int i=0;i<len;i++){
      DocId did = dids[i];
      Document doc = (Document)model.getDocument(did.getId());
      if(!(doc instanceof edu.lehigh.swat.hawk.core.Ontology))
        continue;
      edu.lehigh.swat.hawk.core.Ontology ionto = (edu.lehigh.swat.hawk.core.Ontology)doc;
      int iseq = model.getOntSeq(did.getId());
      edu.lehigh.swat.hawk.core.OntClass[] iclss = ionto.getAllPlusImportedClasses();
      int clen = iclss.length;
      for(int j=0;j<clen;j++){
        edu.lehigh.swat.hawk.core.OntClass icls = iclss[j];
        ObjectId cid = icls.getID();
        String tableName = model.getTableName(cid);
        if(tableName==null)
          continue;
        String viewName = tableName+"_"+ontSeq+"_view";

        String ivName = tableName+"_"+iseq+"_view";
        String vdef = model.getViewDefinition(ivName);
        if(vdef==null){
         System.out.println("ivname:" + ivName);
         continue;
       }
        int start = vdef.indexOf(" WHERE ");
        int end = vdef.indexOf(" UNION");
        if(end<1)
            end = vdef.length();
        String oldWhere = vdef.substring(start, end);
        String newOnto = " or onto ="+ontSeq;

        String qs2 = "CREATE VIEW "
            +viewName+" AS\n SELECT * FROM "+tableName+ oldWhere + newOnto;

        try{
          String qs3 = "INSERT INTO view_definition VALUES ('"+viewName+"', '"+qs2+"')";
          stmt.execute(qs2);
      //    System.out.println(qs2);
          stmt.execute(qs3);
        }
        catch(SQLException e){
        //  log.println("error when store class, create view");
          System.out.println(qs2);
          System.out.println("error when store imported class, create view");
          System.out.println("SQLState:"+e.getSQLState());
          System.out.println("Message :"+e.getMessage());
          System.out.println("Vendor  :"+e.getErrorCode());

        }
      }
      edu.lehigh.swat.hawk.core.OntProperty[] iprops = ionto.getAllPlusImportedProperties();
      int plen = iprops.length;
      for(int j=0;j<plen;j++){
        edu.lehigh.swat.hawk.core.OntProperty iprop = iprops[j];
        ObjectId pid = iprop.getID();
        String tableName = model.getTableName(pid);
        if(tableName==null)
          continue;
        tableName = tableName+"_p";
        String viewName = tableName+"_"+ontSeq+"_view";
        String ivName = tableName+"_"+iseq+"_view";
       // String ptype = (String)model.getPropertyTypes().get(tableName+"_p");
       // if(ptype!=null&&ptype.equals("hasinverse"))
       //         ivName = tableName+"_"+"p_inv_"+iseq+"_view";;

       String vdef = model.getViewDefinition(ivName);
       if(vdef==null){
        System.out.println("ivname:" + ivName);
        continue;
      }

      int start = vdef.indexOf(" WHERE ");
      int end = vdef.indexOf(" UNION");
      if(end<1)
          end = vdef.length();
       String oldWhere = vdef.substring(start, end);
       String newOnto = " or onto ="+ontSeq;

       String qs2 = "CREATE VIEW "
            +viewName+" AS\n SELECT * FROM "+tableName+ oldWhere + newOnto;

        try{
          String qs3 = "INSERT INTO view_definition VALUES ('"+viewName+"', '"+qs2+"')";
          stmt.execute(qs2);
       //   System.out.println(qs2);
          stmt.execute(qs3);
        }
        catch(SQLException e){
          System.out.println(qs2);
          System.out.println("error when store imported property, create view");
          System.out.println("SQLState:"+e.getSQLState());
          System.out.println("Message :"+e.getMessage());
          System.out.println("Vendor  :"+e.getErrorCode());
        }
      }
    }
  }

/*
  private void flushIntersections(){
    //deal with equivalentClass
    edu.lehigh.swat.hawk.core.OntClass[] classes = this.getAllClasses();
    int cNum = classes.length;
    for(int i=0;i<cNum;i++){
      edu.lehigh.swat.hawk.core.OntClass cls = classes[i];
      if(cls.getID().getLocalName()==null||cls.getID().getLocalName()=="")
        continue;
      ObjectId[] eid = cls.getIntersectionOfs();
      String className = model.getTableName(cls.getID());
    //  int oriSeq = model.getOntSeq(cls.getID().getNameSpace());
      if(eid==null)
        continue;
      int sn = eid.length;
      if(sn<=0)
        continue;
      StringBuffer cvb = new StringBuffer("UNION ALL (SELECT * from ");

      for(int j=0;j<sn;j++){

        String tName = model.getTableName(eid[j]);
        String ivName = tName;
        if(tName != null){
            ivName = tName + "_view";
        }
        else{
            String[] ret = this.ViewForRestriction(eid[j]);
            if(ret==null){
                cvb=null;
                break;
            }

            ivName = ret[0];
            cvb.append(ret[1]);
        }
        if(ivName == null)
          continue;
        if(j==0){
            if(ivName.startsWith("(SELECT"))
                cvb.append(ivName.substring(1)).deleteCharAt(cvb.length()).append(" where ID IN ()");
            else
                cvb.append("SELECT * FROM ").append(ivName + " where ID IN ()");
        }
        else{
            int fromind = ivName.indexOf(" FROM ");
            int commaind = ivName.indexOf(",");
            if(fromind<=0)
                cvb.insert(cvb.length() - j,
                       "SELECT ID FROM " + ivName + " AND ID IN()");
            else
                cvb.insert(cvb.length()-j,
                ivName.substring(1,commaind)+ivName.substring(fromind)+" AND ID IN()");
        }
      }
      if(cvb==null)
          continue;
      cvb.delete(cvb.length()-13, cvb.length()-1);

      try{
        String cv = cvb.toString();
        if(dbName.endsWith(".mdb")|| dbName.indexOf("h2")>0){
            if(start!=null)
                stmt.execute(dv);
         stmt.execute(cv);
       }else if(dbName.indexOf("sql")>0){
//           stmt.execute(cvb.insert(7, "OR REPLACE ").toString());
           String cp = cpb.toString();
           stmt.execute(cp);
       }
        String qs3 = "UPDATE view_definition SET definition='"+cv+"'"+
            "WHERE viewname='"+vName+"'";
        stmt.execute(qs3);

      }
      catch(SQLException e){
        System.out.println("error when flush intersections");
        System.out.println(cvb.toString());
        System.out.println("SQLState:"+e.getSQLState());
        System.out.println("Message :"+e.getMessage());
        System.out.println("Vendor  :"+e.getErrorCode());
      }
    }
  }
*/

  /**
   * Get the priorVersion ontologies which are backwardCompatibleWith
   */
  public DocId[] getCompatiblePriorOnts(){
    compatibleOntos = new Vector();
    DocId[] dIds = memoryOnto.getCompatiblePriorOnts();
    if (dIds==null)
      return null;
    int len = dIds.length;
    for(int i=0;i<len;i++){
      DocId did = dIds[i];
      compatibleOntos.add(model.getDocument(did.getId()));
    }
    return dIds;
  }

//  protected int ontSeq;
//  protected edu.lehigh.swat.hawk.storage.dlmemory.Ontology memoryOnto;
  private Vector compatibleOntos;
//  private String dbName;
}
