/*
*Copyright: Copyright (c) 2003-2004, Lehigh University. All rights reserved.
*License Statement: The GNU General Public License
*/


package edu.lehigh.swat.hawk.storage.simpledb;

//import java.util.Set;
import java.sql.*;
import java.sql.Date;
import java.sql.ResultSet;
import java.util.*;

import edu.lehigh.swat.hawk.core.DatatypeValue;
//import edu.lehigh.swat.hawk.core.DocId;
import edu.lehigh.swat.hawk.core.ObjectId;
import edu.lehigh.swat.hawk.storage.StorageModel;
import edu.lehigh.swat.hawk.core.DocId;

/**
 * Representing semantic contents in a document and/or its imported documents
 * @author Z. Pan
 * @version 1.0
 */

public class Document extends edu.lehigh.swat.hawk.storage.simplememory.Document{// edu.lehigh.swat.hawk.core.Document{

  /**
   * Constructor.
   */
  public Document(){
    super();
  }


  /**
   * Create a Individual object.
   */
  public edu.lehigh.swat.hawk.core.Individual createIndividual(){
    Individual indiv = new Individual();
    indiv.setSource(this);
    indiv.setSQLStatement(stmt);
    return indiv;
  }


  /**
   * Add an individual.
   */
  public void addIndividual(edu.lehigh.swat.hawk.core.Individual indiv){
    super.addIndividual(indiv);
  }

  /**
   * Delete an individual.
   */
  public void deleteIndividual(edu.lehigh.swat.hawk.core.Individual indi){
    super.deleteIndividual(indi);

    int indivId = model.getUrlIndex(indi.getID().getId());
    ObjectId[] sclasses = indi.getSourceClasses();
      int len = sclasses.length;
      for(int j=0;j<len;j++){
          ObjectId scid = sclasses[j];
          String tableName = model.getTableName(scid);
          if (tableName == null)
              continue;
          String qs = "DELETE FROM " + tableName + " WHERE id="
                   + indivId + " AND source=" + docSeq;
          try {
              stmt.executeUpdate(qs);
          }
          catch (SQLException e) {
                    System.out.println("error when delete individual");
                    System.out.println("SQLState:" + e.getSQLState());
                    System.out.println("Message :" + e.getMessage());
                    System.out.println("Vendor  :" + e.getErrorCode());
            }
      }
      ObjectId[] props = indi.getProperties();
      int plen = props.length;
      for(int m=0; m<plen; m++){
        ObjectId pid = props[m];
        String ptname = model.getTableName(pid);
        if(ptname==null)
          continue;
        String qs = "DELETE FROM " + ptname + "_p" + " WHERE subject="
                   + indivId + " AND source=" + docSeq;
        try {
              stmt.executeUpdate(qs);
        }
        catch (SQLException e) {
              System.out.println("error when delete individual property values");
              System.out.println(qs);
              System.out.println("SQLState:" + e.getSQLState());
              System.out.println("Message :" + e.getMessage());
              System.out.println("Vendor  :" + e.getErrorCode());
        }
      }
  }

  /**
   * Set the document sequence number.
   */
  public void setDocSeq(int i){
    docSeq = i;
  }

  /**
   * Get the document sequence number.
   */
  public int getDocSeq(){
    return docSeq;
  }

  /**
   * Set the SQL statement.
   */
  public void setSQLStatement(Statement statement){
    stmt = statement;
  }

  /**
   * Set the storageModel.
   */
  public void setModel(StorageModel m){
    model = (DatabaseStorage)m;
  }

  /**
   * Get the storageModel.
   */
  public StorageModel getModel(){
    return model;
  }


  /**
   * Flush the axioms into database.
   */
  public void flush(){
    Vector<String> iontos = new Vector<String>();
    edu.lehigh.swat.hawk.storage.simpledb.Ontology tempOnto = null;
    edu.lehigh.swat.hawk.core.Individual[] indis = this.getAllIndividuals();
    int lens = indis.length;
//long t0 = System.currentTimeMillis();
    for(int i=0;i<lens;i++){
      edu.lehigh.swat.hawk.core.Individual indiv = indis[i];
      int indivId = -1;
      if(indiv.getID().getId().startsWith("[")){ //zhp2:new for hawk-eye
          indivId = this.findAlternateId(indiv);
      }
      if(indivId<0)
          indivId = model.getUrlIndex(indiv.getID().getId());
      ObjectId[] sclasses = indiv.getSourceClasses();
      int len = sclasses.length;

      for(int j=0;j<len;j++){
        ObjectId scid = sclasses[j];
        String tableName = model.getTableName(scid);
        if(tableName==null)
          continue;
        if(!iontos.contains(scid.getNameSpace()))
         iontos.add(scid.getNameSpace());

        int[] ontNums = model.decideCommitOnto(this,scid);
        int ontlen = ontNums.length;
        for(int k=0;k<ontlen;k++){
            String qs = "INSERT INTO " + tableName + " VALUES ("
                + indivId + ", " + docSeq + ", " + ontNums[k] + ")";
    if (model.dbName.indexOf("mysql")>0)
        qs = "INSERT ignore INTO " + tableName + " VALUES ("
                + indivId + ", " + docSeq + ", " + ontNums[k] + ")";
  //zhp2: begin insert individual_occurrence
    tempOnto = (edu.lehigh.swat.hawk.storage.simpledb.Ontology)
          model.getDocument(scid.getNameSpace().replace('#', ' ').trim());
    String qs2 = "";
      if(tempOnto!=null){
        String ind = tempOnto.getOntSeq()+", "+tempOnto.getClassIndex(scid)+",0";
        if(model.dbName.indexOf("sqlite")>0)
            qs2="Insert or ignore into individual_occurrence values("+indivId+", "+ind+")";
        else if (model.dbName.indexOf("jdbc:db2:")>0)
            qs2="Insert into individual_occurrence values("+indivId+", "+ind+")";
        else
            qs2 = "Insert ignore into individual_occurrence values("+indivId+", "+ind+")";
    }
  //end
            try {
//long t0 = System.currentTimeMillis();
              stmt.executeUpdate(qs);
//long t1 = System.currentTimeMillis()-t0;
//System.err.println("insert class table: "+t1);
              if(qs2.length()>1){
           /*       ResultSet rs = stmt.executeQuery(
                          "select * from individual_occurrence where id="
                          +indivId+" and ontid="+tempOnto.getOntSeq()
                          +" and termid="+tempOnto.getClassIndex(scid));
                  if(rs==null || !rs.next())  */
//t0 = System.currentTimeMillis();
                     stmt.executeUpdate(qs2);
//t1 = System.currentTimeMillis()-t0;
//System.err.println("insert occurrence table: "+t1);
              }
            }
            catch (SQLException e) {
        //      if(e.getSQLState()!=null&&!e.getSQLState().equals("23000")){
        //        System.out.println("error when store individual");
        //        System.out.println("SQLState:" + e.getSQLState());
                System.err.println("Message :" + e.getMessage());
        //        System.out.println("Vendor  :" + e.getErrorCode());
                System.out.println(qs2);
        //      }
        //      else{
       //         System.out.println("error when store individual");
       //         System.out.println("Message :" + e.getMessage());
       //         System.out.println("Vendor  :" + e.getErrorCode());
       //         System.out.println(qs2);
       //       }
          }
        }
      }

      ObjectId[] props = indiv.getProperties();
      int plen = props.length;
      for(int m=0; m<plen; m++){
//long t0 = System.currentTimeMillis();
        ObjectId pid = props[m];
        String ptname = model.getTableName(pid);
        if(ptname==null)
          continue;
        ptname = ptname+"_p";
        tempOnto = (edu.lehigh.swat.hawk.storage.simpledb.Ontology)
          model.getDocument(pid.getNameSpace().replace('#', ' ').trim());
        if(!iontos.contains(pid.getNameSpace()))
          iontos.add(pid.getNameSpace());

      //zhp2: begin insert individual
         String qs3 = "";
         if(tempOnto!=null){
             try{
             String ind = tempOnto.getOntSeq()+", "+tempOnto.getPropertyIndex(pid)+",1";
             if(model.dbName.indexOf("sqlite")>0)
                 qs3="Insert or ignore into individual_occurrence values("+indivId+", "+ind+")";
             else if (model.dbName.indexOf("jdbc:db2:")>0)
                qs3="Insert into individual_occurrence values("+indivId+", "+ind+")";
             else
                qs3 = "Insert ignore into individual_occurrence values("+indivId+", "+ind+")";
          /*   ResultSet rs = stmt.executeQuery(
                          "select * from individual_occurrence where id="
                          +indivId+" and ontid="+tempOnto.getOntSeq()
                          +" and termid="+tempOnto.getClassIndex(pid));
             if(rs==null || !rs.next())  */
//long t0 = System.currentTimeMillis();

              stmt.executeUpdate(qs3);

//long t1 = System.currentTimeMillis()-t0;
//System.err.println("insert occurrence table: "+t1);
             }catch(SQLException e) {
          //       if(e.getSQLState()!=null&&!e.getSQLState().equals("23000")){
          //           System.out.println("error when store individual occurrence info");
          //           System.out.println("SQLState:" + e.getSQLState());
                     System.err.println("Message :" + e.getMessage());
          //           System.out.println("Vendor  :" + e.getErrorCode());
                     System.out.println(qs3);
          //       }
          //       else{
          //           System.out.println("error when store individual occurrence info");
          //           System.out.println("Message :" + e.getMessage());
          //           System.out.println("Vendor  :" + e.getErrorCode());
          //           System.out.println(qs3);
          //       }
            }
         }


        int[] ontoNums = model.decideCommitOnto(this, pid);
        ObjectId[] values = indiv.getValuesForProperty(pid);
        int vlen = values.length;
//System.out.println(vlen+" values for "+ptname);
        for (int n=0; n<vlen; n++) {
          ObjectId v = values[n];
          int ontolen = ontoNums.length;
          String qs = "";
          String qs2="";
          String qs4 = "";
          for(int p=0;p<ontolen;p++){
              int valueId = 0;
              if (v instanceof DatatypeValue) {
                  if(((DatatypeValue) v).getValue()==null)
                      continue;
              //    boolean validDate = true;
                                    if(tempOnto!= null && tempOnto.getProperty(pid)!=null && tempOnto.getProperty(pid).getRange()!=null){
                                        if(tempOnto.getProperty(pid).getRange().getLocalName().toLowerCase().endsWith("date")){ // Ameet, Aug 31, 2007
                                            try{
                                                Date date = Date.valueOf(((DatatypeValue) v).getValue());
                                            }catch(IllegalArgumentException e){
                  //                              validDate = false;
                                                System.out.println(((DatatypeValue) v).getValue()+"Date value doesn't conform to YYYY-MM-DD specification");
                                                e.printStackTrace();
                                            }
                                        }
                                    }
                            //        if(validDate){
                            if(model.dbName.indexOf("jdbc:db2:")>0)
                                qs = "INSERT INTO " + ptname + " VALUES ("
      + indivId + ", '" + ((DatatypeValue) v).getValue().replaceAll("\"","\"\"") +
      "', " +
      docSeq
      + ", " + ontoNums[p] + ")";
                  else
                                        qs = "INSERT ignore INTO " + ptname + " VALUES ("
                                              + indivId + ", \"" + ((DatatypeValue) v).getValue().replaceAll("\"","\"\"") +
                                              "\", " +
                                              docSeq
                                              + ", " + ontoNums[p] + ")";
                             ///       }
              } else { //object property value
                  valueId = model.getUrlIndex(v.getId());
                  if(tempOnto.getProperty(pid)==null||valueId<0){
                      System.out.println("can't find property or object: "+pid.getId());
                      continue;
                  }
                  if (tempOnto!= null && tempOnto.getProperty(pid)!=null && tempOnto.getProperty(pid).isTransitive()) {
                      if (model.getDBName().indexOf(".mdb") > 0)
                          qs2 = "insert into " + ptname +
                                " select * from (select " + indivId +
                                ", " + ptname +
                                ".object" + "," + docSeq + "," + ontoNums[p] +
                                "\nfrom " + ptname + " \n" +
                                "where " + valueId + "=" + ptname +
                                ".subject\n" +
                                "union\n" +
                                "select " + ptname + ".subject, " + valueId +
                                "," + docSeq + "," +
                                ontoNums[p] +
                                "\nfrom " + ptname + " \n" +
                                "where " + indivId + "=" + ptname +
                                ".object\n" +
                                "union\n" +
                                "select tc1.subject, tc2.object" + "," + docSeq +
                                "," +
                                ontoNums[p] +
                                "\nfrom " + ptname + " as tc1, " + ptname +
                                " as tc2\n" +
                                "where tc1.object=" + indivId +
                                " and tc2.subject=" + valueId + ")";
                      else if (model.dbName.indexOf("jdbc:db2:")>0)
                          qs2 = "insert into " + ptname + " select " + indivId +
                                ", " + ptname +
                                ".object" + "," + docSeq + "," + ontoNums[p] +
                                "\nfrom " + ptname + " \n" +
                                "where " + valueId + "=" + ptname +
                                ".subject\n" +
                                "union\n" +
                                "select " + ptname + ".subject, " + valueId +
                                "," + docSeq + "," +
                                ontoNums[p] +
                                "\nfrom " + ptname + " \n" +
                                "where " + indivId + "=" + ptname +
                                ".object\n" +
                                "union\n" +
                                "select tc1.subject, tc2.object" + "," + docSeq +
                                "," +
                                ontoNums[p] +
                                "\nfrom " + ptname + " as tc1, " + ptname +
                                " as tc2\n" +
                                "where tc1.object=" + indivId +
                                " and tc2.subject=" + valueId;
                      else
                          qs2 = "insert ignore into " + ptname + " select " + indivId +
                                ", " + ptname +
                                ".object" + "," + docSeq + "," + ontoNums[p] +
                                "\nfrom " + ptname + " \n" +
                                "where " + valueId + "=" + ptname +
                                ".subject\n" +
                                "union\n" +
                                "select " + ptname + ".subject, " + valueId +
                                "," + docSeq + "," +
                                ontoNums[p] +
                                "\nfrom " + ptname + " \n" +
                                "where " + indivId + "=" + ptname +
                                ".object\n" +
                                "union\n" +
                                "select tc1.subject, tc2.object" + "," + docSeq +
                                "," +
                                ontoNums[p] +
                                "\nfrom " + ptname + " as tc1, " + ptname +
                                " as tc2\n" +
                                "where tc1.object=" + indivId +
                                " and tc2.subject=" + valueId;
                  }
/*
                    if(tempOnto!=null && tempOnto.getProperty(pid)!=null && tempOnto.getProperty(pid).isInverseFunctional()){
                      String qsif = "select subject from "+ptname
                                   +" where object="+valueId;
                      try{
//long t00 = System.currentTimeMillis(); //zhp2 test
                          ResultSet rs = stmt.executeQuery(qsif);
//long t11 = System.currentTimeMillis()-t00;
//System.out.println("find same as:"+t11);
                          Vector sameAs = new Vector();
                          if(rs!=null){
                              while(rs.next()){
                                  int sub = rs.getInt(1);
                                  sameAs.add(new Integer(sub));
                              }
                              this.addSameIndividualsSet(sameAs);
                          }
                      }catch(SQLException e){
                          e.printStackTrace();
                      }
                  }
*/
                  qs = "INSERT INTO " + ptname + " VALUES ("
                           + indivId + ", " + valueId + ", " + docSeq + ", " +
                           ontoNums[p] + ")";
                  if (model.dbName.indexOf("mysql")>0)
                      qs = "INSERT ignore INTO " + ptname + " VALUES ("
                           + indivId + ", " + valueId + ", " + docSeq + ", " +
                           ontoNums[p] + ")";


                      //zhp2: begin insert individual occurrence
                      if(tempOnto!=null){
                          String ind = tempOnto.getOntSeq()+", "+tempOnto.getPropertyIndex(pid)+",2";
                          if(model.dbName.indexOf("sqlite")>0)
                              qs4 = "Insert or ignore into individual_occurrence values("+valueId+", "+ind+")";
                          else if (model.dbName.indexOf("jdbc:db2:")>0)
                              qs4 = "Insert into individual_occurrence values("+valueId+", "+ind+")";
                          else
                              qs4 = "Insert ignore into individual_occurrence values("+valueId+", "+ind+")";
                      }


              }//end else for object property

                  try {
//long t0 = System.currentTimeMillis();
                      stmt.executeUpdate(qs);
//long t1 = System.currentTimeMillis()-t0;
//System.err.println("insert property table: "+t1);
                      //zhp2: symmetric
                      if (tempOnto!= null && tempOnto.getProperty(pid)!=null && tempOnto.getProperty(pid).isSymmetric()) {
                          String qss = "INSERT INTO " + ptname + " VALUES ("
                           + valueId + ", " + indivId + ", " + docSeq + ", " +
                           ontoNums[p] + ")";
                         stmt.executeUpdate(qss);
                      }
                      if (!qs2.equals("")){
//t0 = System.currentTimeMillis();
                          stmt.executeUpdate(qs2);
//t1 = System.currentTimeMillis()-t0;
//System.err.println("insert transitive property table: "+t1);
                      }
                      if (!qs4.equals("")){
                   //       ResultSet rs = stmt.executeQuery(
                   //       "select * from individual_occurrence where id="
                  //        +valueId+" and ontid="+tempOnto.getOntSeq()
                  //        +" and termid="+tempOnto.getClassIndex(pid));
                  //       if(rs==null || !rs.next())
//t0 = System.currentTimeMillis();
                              stmt.executeUpdate(qs4);
//t1 = System.currentTimeMillis()-t0;
//System.err.println("insert property occurrence table: "+t1);
                      }
                  } catch (SQLException e) {
                      if(e.getSQLState()!=null&&!e.getSQLState().equals("23505")){
                    //    System.out.println("error when store individual property value");
                        System.out.println("SQLState:" + e.getSQLState());
                        System.err.println("Message :" + e.getMessage());
                    //    System.out.println("Vendor  :" + e.getErrorCode());
                        System.out.println(qs);
                      }
                   //   else{
                    //    System.out.println("error when store individual property value");
                    //    System.out.println("Message :" + e.getMessage());
                    //    System.out.println("Vendor  :" + e.getErrorCode());
                    //    System.out.println(qs);
                   //  }
                  }
          }
        }// end for vlen
//long t1 = System.currentTimeMillis()-t0;
//System.out.println("add property values:"+t1);
      }//end for plen

    }//end for individual lens


//long t0 = System.currentTimeMillis();
    //zhp2: start to process sameAS
    Collection[] sameSets = this.getSameIndividualsSets();
    int slen = sameSets.length;
    for(int i=0;i<slen;i++){

        Collection sameSet = sameSets[i];
        if(sameSet.size()<2)
            continue;
        if(sameSet.toArray()[0] instanceof ObjectId){
            Object[] uris = sameSet.toArray();
            int ulen = uris.length;
            for(int u=0;u<ulen;u++){
                ObjectId uoid = (ObjectId)uris[u];
                int uind = model.getUrlIndex(uoid.getId());
                sameSet.remove(uoid);
// System.err.println("same ind: "+((ObjectId)uris[u]).getId());
                sameSet.add(uind);
                while(model.getKnownUrls().values().remove(uind)){
                    continue;
                }
            }
        }

//        int maxRows = 0;
        int maxId = 0;
/*
        Iterator it = sameSet.iterator();
        while(it.hasNext()){
            Object obj = it.next();
            Integer sind = (Integer)obj;
            try{
                 ResultSet res =stmt.executeQuery(
                          "select count(0) from individual_occurrence where id=" +
                          sind);
                 if(res!=null && res.next()){
                      int tnum = res.getInt(1);
                //      if(tnum<=0)
               //          sameSet.remove(sind);
                      if(tnum>maxRows){
                          maxRows = tnum;
                          maxId = sind;
                      }
                  }
              }catch(SQLException e){
                    e.printStackTrace();
                }
        }
 */
        Object[] sameIds = sameSet.toArray();
        int ilen = sameIds.length;
        for(int j=0;j<ilen;j++){
            int ind = (Integer)sameIds[j];
            if(maxId ==0)  //zhp2:
                maxId = ind; // just use the first one as the canonical id.
            if(ind!=maxId)
                substituteId(ind, maxId);
        }
    }
//long t1 = System.currentTimeMillis()-t0;
//System.err.println("deal same as:"+t1);
  }

  private void substituteId(int orig, int targ){
      try{
/*
          stmt.executeUpdate("update uri_index set id="+targ+" where id="+orig);
          stmt.clearBatch();
          ResultSet rs = stmt.executeQuery(
                  "select tablename, tables_index.termid, tables_index.ontid from individual_occurrence, tables_index"
                 +" where id="+orig
                 +" and individual_occurrence.termid=tables_index.termid"
                 +" and individual_occurrence.ontid=tables_index.ontid");

          if(rs==null)
              return;
          Vector<String> updates = new Vector();

          while(rs.next()){
              String tableName = rs.getString(1);
              int tableTermId = rs.getInt(2);
              int ontId = rs.getInt(3);

              String qs = "";
              String qs2 = "";
              if(tableTermId>0){
                  qs="update ignore "+tableName+" set id="+targ+" where id="+orig;
                  qs2="insert ignore individual_occurrence values("+targ+","+ontId+","+tableTermId+")";
          //        System.out.println(qs);
                  stmt.addBatch(qs);
                  stmt.addBatch(qs2);
                  updates.add(qs);
              }
              else{
                  qs="update ignore "+tableName+" set subject="+targ+" where subject="+orig;
                  qs2="insert ignore individual_occurrence values("+targ+","+ontId+","+tableTermId+")";
  //                System.out.println(qs);
                  stmt.addBatch(qs);
                  stmt.addBatch(qs2);
                  updates.add(qs);
  //                if(model.getPropertyTypes()==null)
  //                    System.out.println("propty types null");
  //                if(model.getPropertyTypes().get(tableName)==null)
  //                    System.out.println("can't find table "+tableName);
                  if(model.getPropertyTypes().get(tableName).equals("object")||model.getPropertyTypes().get(tableName).equals("hasinverse"))
                  {
                      qs="update ignore "+tableName+" set object="+targ+" where object="+orig;
                      //       System.out.println(qs);
                      stmt.addBatch(qs);
                      updates.add(qs);
                  }
              }
          }

          stmt.addBatch("delete from individual_occurrence where id="+orig);
//long t0 = System.currentTimeMillis();
          stmt.executeBatch();
//long t1 = System.currentTimeMillis()-t0;
//System.out.println("update tables: "+t1);
//System.out.println("update table "+t1+" :"+qs);
//          int ulen = updates.size();
//          for(int i=0;i<ulen;i++){
//long t0 = System.currentTimeMillis();
//              String qs = updates.get(i);
//              stmt.executeUpdate(qs);
//long t1 = System.currentTimeMillis()-t0;
//System.out.println("update table "+t1+" :"+qs);
//         }
*/
      String qs = "CALL substituteid("+orig+", "+targ+")";
      stmt.execute(qs);
      }catch(SQLException e){
          System.out.println("error when process sameAs");
          //System.out.println("SQLState:" + e.getSQLState());
          System.out.println("Message :" + e.getMessage());
          System.out.println("Vendor  :" + e.getErrorCode());
      }
  }

  private int findAlternateId(edu.lehigh.swat.hawk.core.Individual ind){
     ObjectId[] props = ind.getProperties();
     int plen = props.length;
     if(plen<=0){
         return -1;
     }
     for(int m=0; m<plen; m++){
        ObjectId pid = props[m];
        String ptname = model.getTableName(pid);
        if(ptname==null)
          continue;
        ptname = ptname+"_p";
        Ontology tempOnto = (edu.lehigh.swat.hawk.storage.simpledb.Ontology)
        model.getDocument(pid.getNameSpace().replace('#', ' ').trim());
        if(tempOnto!=null && tempOnto.getProperty(pid)!=null && tempOnto.getProperty(pid).isInverseFunctional()){
            if(!model.getPropertyTypes().get(ptname).equals("object")&&!model.getPropertyTypes().get(ptname).equals("hasinverse"))
                continue;
            ObjectId[] values = ind.getValuesForProperty(pid);
            int vlen = values.length;

            for (int n=0; n<vlen; n++) {
              ObjectId v = values[n];
              int valueId = model.getUrlIndex(v.getId());
// System.out.println("try to find subject for "+valueId);
              if(valueId<0)
                  continue;
              String qsif = "select subject from "+ptname
                         +" where object="+valueId;
              try{
                ResultSet rs = stmt.executeQuery(qsif);
                if(rs!=null && rs.next()){
                        int sub = rs.getInt(1);
                        return sub;
                }
              }catch(SQLException e){
                 System.out.println(e.getMessage());
                  //e.printStackTrace();
              }
           }
      }
    }
    return -1;
  }

  /**
   * Add an imports statement.
   */
  public void addImports(DocId id){
    imports.add(id);
 /*
    edu.lehigh.swat.hawk.core.Document doc = model.getDocument(id.getId());
    if(doc instanceof edu.lehigh.swat.hawk.storage.simpledb.Ontology){
        Ontology ont = (edu.lehigh.swat.hawk.storage.simpledb.Ontology)doc;
        DocId[] ancs = ont.getAncestors();
        int len = ancs.length;
        for(int i=0;i<len;i++){
            if(!ancestors.contains(ancs[i]))
                ancestors.add(ancs[i]);        }
    }
 */
  }


  public DocId[] getAncestors(){
      int len = ancestors.size();
      DocId[] ancs = new DocId[len];
      ancestors.toArray(ancs);
      return ancs;
  }

  private int docSeq;
  protected Statement stmt;
  protected DatabaseStorage model;
  protected ArrayList ancestors;
}
